# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define reltag .GA_redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define section free

%define shortname jdom

Name:           jdom-eap6
Version:        1.1.2
Release:        1%{?reltag}%{?dist}
Epoch:          0
Summary:        Java alternative to DOM and SAX
License:        BSD
URL:            http://www.jdom.org/
Group:          Development/Libraries
Source0:        http://www.jdom.org/dist/source/jdom-1.1.2.tar.gz
Source1:        http://repo1.maven.org/maven2/org/jdom/jdom/1.1.2/jdom-1.1.2.pom
Patch0:         jdom-crosslink.patch
Patch1:         jdom-OSGiManifest.patch
Patch2:         jdom-pom.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jaxen
Requires:       jpackage-utils
BuildRequires:  ant >= 0:1.6
BuildRequires:  jpackage-utils >= 0:1.6
BuildRequires:  java-javadoc
BuildRequires:	jaxen
BuildRequires:  xerces-j2
BuildRequires:  xml-commons-jaxp-1.3-apis
%if %with repolib
BuildRequires:  maven2-plugin-deploy
%endif
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
JDOM is, quite simply, a Java representation of an XML document. JDOM
provides a way to represent that document for easy and efficient
reading, manipulation, and writing. It has a straightforward API, is a
lightweight and fast, and is optimized for the Java programmer. It's an
alternative to DOM and SAX, although it integrates well with both DOM
and SAX.

%package        -n %{shortname}
Summary:        Java alternative to DOM and SAX
Group:          Development/Libraries

%description    -n %{shortname}
JDOM is, quite simply, a Java representation of an XML document. JDOM
provides a way to represent that document for easy and efficient
reading, manipulation, and writing. It has a straightforward API, is a
lightweight and fast, and is optimized for the Java programmer. It's an
alternative to DOM and SAX, although it integrates well with both DOM
and SAX.

%package -n %{shortname}-javadoc
Summary:        Javadoc for %{shortname}
Group:          Documentation
Requires:       jpackage-utils

%description -n %{shortname}-javadoc
Javadoc for %{shortname}.

%package -n %{shortname}-demo
Summary:        Demos for %{shortname}
Group:          Development/Libraries
Requires:       %{shortname} = %{epoch}:%{version}-%{release}

%description -n %{shortname}-demo
Demonstrations and samples for %{shortname}.

%if %with repolib
%package -n %{shortname}-repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description -n %{shortname}-repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -n %{shortname}
%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1
cp -p %{SOURCE1} jdom-%{version}.pom
%patch2 -p1 -b .sav2

find -type f -name "*.jar" | xargs -t rm
pushd lib
ln -s `%{_bindir}/build-classpath jaxen` jaxen.jar
ln -s `%{_bindir}/build-classpath xercesImpl` xerces.jar
ln -s `%{_bindir}/build-classpath xml-commons-jaxp-1.3-apis` xml-apis.jar
popd

#sed -i -e 's|<property name="build.compiler".*||' build.xml

%build
export CLASSPATH=
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=first -Dversion=%{namedversion} -Dj2se.apidoc=%{_javadocdir}/java master javadoc-link

# JBoss Enterprise Application Platform JBPAPP-7569
# org.jdom:jdom:1.1.2-redhat-1 is missing class org.jdom.xpath.JaxenXPath
[ -f build/classes/org/jdom/xpath/JaxenXPath.class ] || exit 1

%install
rm -rf %{buildroot}

# jars
mkdir -p %{buildroot}%{_javadir}
cp -p build/jdom-%{namedversion}.jar %{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}.jar; do ln -s ${jar} `/bin/echo ${jar} | sed "s|-%{namedversion}||g"`; done)

# Alternative JAR location
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/%{name}
install -p -m 644 build/jdom-%{namedversion}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}/%{shortname}-%{namedversion}.jar

(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}.jar; do ln -s ${jar} `/bin/echo ${jar} | sed "s|-%{namedversion}||g"`; done)

# pom
mkdir -p %{buildroot}%{_datadir}/maven2/poms
cp -p %{shortname}-%{version}.pom %{buildroot}%{_datadir}/maven2/poms/JPP-%{shortname}.pom
%add_to_maven_depmap org.jdom jdom %{namedversion} JPP %{shortname}
%add_to_maven_depmap jdom jdom %{namedversion} JPP %{shortname}

# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
cp -pr build/apidocs/* %{buildroot}%{_javadocdir}/%{shortname}-%{namedversion}
ln -s %{shortname}-%{namedversion} %{buildroot}%{_javadocdir}/%{shortname}

# demo
mkdir -p %{buildroot}%{_datadir}/%{shortname}
cp -pr samples %{buildroot}%{_datadir}/%{shortname}

%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
#export MAVEN_OPTS="-Xms1g -Xmx1g"
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repo.local=${MAVEN_REPO_LOCAL} -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-%{shortname}.pom -Dfile=%{buildroot}%{_javadir}/%{shortname}-%{namedversion}.jar -DrepositoryId=jboss-releases-repository -Durl=${URL}
%endif

%clean
rm -rf %{buildroot}

%post -n %{shortname}
%update_maven_depmap

%postun -n %{shortname}
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/%{shortname}-%{namedversion}.jar
%{_javadir}*/%{name}/%{shortname}.jar

%files -n %{shortname}
%defattr(0644,root,root,0755)
%doc CHANGES.txt COMMITTERS.txt LICENSE.txt README.txt TODO.txt
%{_javadir}*/%{shortname}-%{namedversion}.jar
%{_javadir}*/%{shortname}.jar
%{_datadir}/maven2/poms/JPP-%{shortname}.pom
%{_mavendepmapfragdir}/%{name}

%files -n %{shortname}-javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{shortname}-%{namedversion}
%{_javadocdir}/%{shortname}

%files -n %{shortname}-demo
%defattr(0644,root,root,0755)
%{_datadir}/%{shortname}

%if %with repolib
%files -n %{shortname}-repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Wed Apr 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.1.2-1.GA_redhat_1
- Fix Release: tag

* Wed Apr 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.1.2-0.7.GA_redhat_1.1
- Fix Release: tag

* Wed Apr 18 2012 Permaine Cheung <pcheung@redhat.com> - 0:1.1.2-0.6_redhat_1.1
- Update pom patch (vman), Release: tag

* Tue Apr 03 2012 Martha Benitez <mbenitez@redhat.com> - 0:1.1.2-0.5_redhat_1.2
- Rebuild with a -eap6 suffix to avoid conflict with RHEL-6 base

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.1.2-0.5_redhat_1.1
- Rebuild using cache signing

* Tue Nov 22 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-0.5
- add jaxen support

* Wed Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-0.4
- rebuild due to failed MEAD import

* Wed Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-0.3
- rebuild due to failed MEAD import

* Wed Nov 09 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-0.2
- Requires: jaxen
- fix version
- fix repolib file list
- remove old source tarball from CVS

* Thu Oct 27 2011 David Walluck <dwalluck@redhat.com> 0:1.1.2-0.1
- 1.1.2
- remove GCJ support
- fix javadoc Requires
- fix maven deploy

* Wed Mar 23 2011 Vaclav Tunka <vtunka@redhat.com> 0:1.1.1-2.1
- Merge from RHEL 6
- Rebase to 1.1.1.
- Remove gcj support
- Fix license to be BSD
- Add Requires: xalan-j2
- Fix group names
- Use the RHEL6 jdom-crosslink.patch

* Wed Jan 19 2011 Vaclav Tunka <vtunka@redhat.com> 0:1.0-4.5.1
- Rebuild

* Tue Nov 23 2010 Vaclav Tunka <vtunka@redhat.com> 0:1.0-4.4.1
- Add upload.sh and content of maven2-brew to repolib
- add BuildRequires: maven2
- add BuildRequires: maven-deploy-plugin

* Mon Aug 23 2010 David Walluck <dwalluck@redhat.com> 0:1.0-4.4
- add pom
- add repolib
- drop (Build)Requires: xalan-j2

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0-4.3.1
- rebuilt

* Wed Apr 7 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.0-4.3
- Rebuild

* Wed Feb 25 2010 Fernando Nasser <fnasser@redhat.com> - 0:1.0-4.2
- Rebuild

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> - 0:1.0-4jpp.ep1.1
- Rebuild noarch

* Fri Aug 04 2006 Deepak Bhole <dbhole@redhat.com> - 0:1.0-4jpp.1
- Added missing requirements.
- Remove jaxen requirement, since we don't have it in fc yet.
- Merge with fc spec.

* Tue Apr 11 2006 Ralph Apel <r.apel at r-apel.de> - 0:1.0-3jpp
- First JPP-1.7 release
- Drop false xalan dependency

* Tue Oct 11 2005 Ralph Apel <r.apel at r-apel.de> - 0:1.0-2jpp
- Add jaxen to Requires and classpath

* Sat Sep 18 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-1jpp
- Upgrade to 1.0 final

* Tue Sep 07 2004 Ralph Apel <r.apel at r-apel.de> - 0:1.0-0.rc1.1jpp
- Upgrade to 1.0-rc1

* Sun Aug 23 2004 Randy Watler <rwatler at finali.com> - 0:1.0-0.b9.4jpp
- Rebuild with ant-1.6.2

* Mon Jul 19 2004 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b9.3jpp
- Add non-versioned javadoc dir symlink.
- Crosslink with local J2SE javadocs.

* Thu Jan 22 2004 David Walluck <david@anti-microsoft.org> 0:1.0-0.b9.2jpp
- fix URL

* Wed Jan 21 2004 David Walluck <david@anti-microsoft.org> 0:1.0-0.b9.1jpp
- b9
- don't use classic compiler

* Thu Mar 27 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.0-0.b8.2jpp
- Adapted to JPackage 1.5.
- Use sed instead of bash 2 extension when symlinking jars during build.

* Wed May 08 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b8.1jpp
- vendor, distribution, group tags

* Sat Jan 19 2002 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b7.6jpp
- versioned dir for javadoc
- requires xalan-j2 >= 2.2.0
- no dependencies for javadoc package
- stricter dependency for demo package
- section macro

* Wed Dec 5 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b7.5jpp
- javadoc into javadoc package

* Wed Nov 21 2001 Christian Zoffoli <czoffoli@littlepenguin.org> 1.0-0.b7.4jpp
- removed packager tag
- new jpp extension
- added xalan 2.2.D13 support

* Sat Oct 6 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b7.3jpp
- used original tarball

* Sun Sep 30 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b7.2jpp
- first unified release
- s/jPackage/JPackage

* Mon Sep 17 2001 Guillaume Rousse <guillomovitch@users.sourceforge.net> 1.0-0.b7.1mdk
- Requires and BuildRequires xalan-j2
- vendor tag
- packager tag
- s/Copyright/License/
- truncated description to 72 columns in spec
- spec cleanup
- used versioned jar
- added demo package

*  Sat Feb 17 2001 Guillaume Rousse <g.rousse@linux-mandrake.com> 1.0b6-1mdk
- first Mandrake release
